/*
 * CatalogueHandler.java
 *
 * Created on 10 de agosto de 2004, 18:06
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.PriceScale;
import com.fenalco.entities.SupplierProduct;
import com.fenalco.entities.SupplierProductList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * Este servlet responde ante la petición de activar o desactivar un producto
 * del proveedor del catálogo de productos.
 * 
 * @author andres
 */
public class CatalogueHandler extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Recibe una arreglo con los valores de los checkbox de activación de los
	 * productos, este arreglo lleva como valor un string con el identificador
	 * del producto del proveedor
	 * 
	 * Se un llamado a la función <CODE>changeState</CODE> de un objeto de
	 * tipo <CODE>SupplierProduct</CODE> que recibe como parámetro el id del
	 * producto <CODE>supplierProductId</CODE>, una transacción y el nuevo
	 * estado para el el producto.
	 * 
	 * Redirecciona la navegación al servlet encargado de construir la vista del
	 * proveedor catalogoproveedor <CODE>CatalogueView</CODE>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en el procesamiento de la petición
	 * @throws IOException
	 *             Excepción en la operación de escritura por el flujo <CODE>
	 *             PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;

		String url;
		String message;

		//Validación de sesión
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
	
			}
			else
			{
	
				//Verificacion de seleccion de elementos.
				boolean itemsSelected = false;
				String[] items = new String[1];
				if( request.getParameterValues("item") != null )
				{
					items = request.getParameterValues("item");
					itemsSelected = true;
				}
	
				Transaction t = new Transaction();
				boolean flag;
				boolean readyToTransact = true;
				int currentKey;
				int activeKey;
	
				User supplier = (User) session.getAttribute("user");
				SupplierProductList supplierProductList = new SupplierProductList(
						supplier.getCompanyId());
				Hashtable supplierProducts = supplierProductList
						.getSupplierProducts();
				Enumeration e = supplierProducts.keys();
	
				while( e.hasMoreElements() )
				{
					currentKey = ((Integer) e.nextElement()).intValue();
					flag = false;
	
					if( itemsSelected )
					{
						for( int i = 0; i < items.length; i++ )
						{
							activeKey = new Integer(items[i]).intValue();
							if( currentKey == activeKey
									&& PriceScale.existScale(currentKey, supplier
											.getCompanyId()) )
							{ //Match !!
								flag = true;
								break;
							}
						}
					}
	
					if( flag )
					{
						if( !changeStatus(t, currentKey, 1) )
						{
							readyToTransact = false;
							break;
						}
					}
					else
					{
						if( !changeStatus(t, currentKey, 0) )
						{
							readyToTransact = false;
							break;
						}
					}
				}
	
				if( !readyToTransact || !t.execute() )
				{
					//Fallo en la activación de productos para el proveedor
					url = "/proveedor/catalogoproveedor";
					message = "Fallo en la activación de productos";
	
				}
				else
				{
					//Todo OK
					url = "/proveedor/catalogoproveedor";
					message = "La activación de productos finalizó correctamente";
				}
	
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Este método permite activar o desactivar un producto del proveedor
	 * 
	 * @param supplierProductId
	 *            Identificador único del producto ofrecido por el proveedor que
	 *            solicita el cambio de estado activo / inactivo
	 * 
	 * @return Valor booleano que indica si la operación tuvo éxito o no.
	 */
	protected boolean changeStatus( Transaction t, int productKey, int newStatus )
	{
		boolean response = true;

		if( !SupplierProduct.changeStatus(t, productKey, newStatus) )
		{
			response = false;
		}

		return response;
	}

	/**
	 * Maneja el método HTTP <CODE>GET</CODE>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en el procesamiento de la petición
	 * @throws IOException
	 *             Excepción en la operación de escritura por el flujo <CODE>
	 *             PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en el procesamiento de la petición
	 * @throws IOException
	 *             Excepción en la operación de escritura por el flujo <CODE>
	 *             PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una breve descripción del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}